var hlp = 50;
var llp = 100;
var tb = document.getElementById('hltabulka');
var a = [];
var selected = 'A1';
var hl = document.getElementById('horniradek');
var ll = document.getElementById('levyradek');
var rf = false;

var rr = document.getElementById('radek');
rr.addEventListener('keypress',radekzmena,false);
rr.addEventListener('focus',function(){rf=true;},false);
rr.addEventListener('blur',function(){rf=false;},false);

function generuj() {
    generujlistu();
    generujtabulku();
    vyber(selected);
}

tb.addEventListener('scroll',posun,false);
document.addEventListener('keydown',klavesa,false);

function generujlistu(){
    
    hl.innerHTML = '';
    ll.innerHTML = '';
    for (var i = 65; i <= 90; i++) {
        a.push(String.fromCharCode(i));
        hl.innerHTML += '<div class="hl_polozka" id="r'+String.fromCharCode(i)+'">' + String.fromCharCode(i) + '</div>';
    }
    for(var i = 1;i<=100;i++){
        ll.innerHTML += '<div class="ll_polozka" id="r'+i+'">' + i + "</div>";
    }
}

function generujtabulku(){
    for(var x=0;x<100;x++){
        var r = document.createElement('div');
        r.className = 'row';
        for(var y=0;y<a.length;y++){
            var d = document.createElement('div');
            d.id = a[y]+(x+1);
            d.className = 'cell'+(x==0&&y==0?' selected':'');
            d.innerHTML = '';//a[y]+(x+1);
            d.style.fontFamily = 'sans-serif';
            d.addEventListener('click',function(){vyber(this.id)},false);
            r.appendChild(d);
        }
        tb.appendChild(r);
    }
}

function vyber(id){
    $('.selected').removeClass('selected');
    $('.sel').removeClass('sel');
    $('#' + id).addClass('selected');
    $('#r' + id[0]).addClass('sel');
    $('#r' + id.substring(1) ).addClass('sel');
    rr.value = document.getElementById(id).innerHTML;
    selected = id;
    nactirozsireni();
}

function posun(){
    hl.style.left = hlp-tb.scrollLeft + 'px';
    ll.style.top = llp-tb.scrollTop + 'px';
}

function radekzmena(){
    var text = vypocitej(rr.value);
    document.getElementById(selected).innerHTML = text;
    //timeout aby se zobrazilo i posledni pismeno
    setTimeout(radekzmena,10);
}

function klavesa(e){
    var sx = selected.substring(1);
    var sy = selected.charCodeAt(0);
    switch(e.which){
        case 13:if(rf){radekzmena();rr.blur();rf=false;vyber(String.fromCharCode(sy) + (+sx+1));}else{rr.focus();};break;
        case 37:e.preventDefault();if(sy>65)vyber(String.fromCharCode(sy-1) + sx);break;
        case 38:e.preventDefault();if(sx>1)vyber(String.fromCharCode(sy) + (+sx-1));break;
        case 39:e.preventDefault();if(sy<90)vyber(String.fromCharCode(sy+1) + sx);break;
        case 40:e.preventDefault();if(sx<100)vyber(String.fromCharCode(sy) + (+sx+1));break;
        case 27:e.preventDefault();if(rf){rr.blur()};break;
        case 9:e.preventDefault();if(rf){radekzmena();rr.blur();rf=false;if(sy<90)vyber(String.fromCharCode(sy+1) + sx);};break;
        case 8:if(!rf){document.getElementById(selected).innerHTML = ''};break;
    }
}

function vypocitej(a){
    return a;
}

generuj();